// Code generated by gobind. DO NOT EDIT.

// Java class com.proton.gopenpgp.srp.Auth is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=com.proton.gopenpgp github.com/ProtonMail/go-srp
package com.proton.gopenpgp.srp;

import go.Seq;

/**
 * Auth stores byte data for the calculation of SRP proofs.
 * Changed SrpAuto to Auth because the name will be used as srp.SrpAuto by other packages and as SrpSrpAuth on mobile
 * Also the data from the API called Auth. it could be match the meaning and reduce the confusion
 */
public final class Auth implements Seq.Proxy {
	static { Srp.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewAuth Creates new Auth from strings input. Salt and server ephemeral are in
	base64 format. Modulus is base64 with signature attached. The signature is
	verified against server key. The version controls password hash algorithm.
	
	Parameters:
		 - version int: The *x* component of the vector.
		 - username string: The *y* component of the vector.
		 - password []byte: The *z* component of the vector.
		 - b64salt string: The std-base64 formatted salt
	Returns:
	  - auth *Auth: the pre calculated auth information
	  - err error: throw error
	Usage:
	
	Warnings:
		 - Be careful! Poos can hurt.
	 */
	public Auth(long version, String username, byte[] password, String b64salt, String signedModulus, String serverEphemeral) {
		this.refnum = __NewAuth(version, username, password, b64salt, signedModulus, serverEphemeral);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewAuth(long version, String username, byte[] password, String b64salt, String signedModulus, String serverEphemeral);
	
	/**
	 * NewAuthForVerifier Creates new Auth from strings input. Salt and server ephemeral are in
	base64 format. Modulus is base64 with signature attached. The signature is
	verified against server key. The version controls password hash algorithm.
	
	Parameters:
		 - version int: The *x* component of the vector.
		 - username string: The *y* component of the vector.
		 - password []byte: The *z* component of the vector.
		 - salt string:
	Returns:
	  - auth *Auth: the pre calculated auth information
	  - err error: throw error
	Usage:
	
	Warnings:
		 - none.
	 */
	public Auth(byte[] password, String signedModulus, byte[] rawSalt) {
		this.refnum = __NewAuthForVerifier(password, signedModulus, rawSalt);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewAuthForVerifier(byte[] password, String signedModulus, byte[] rawSalt);
	
	Auth(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	public final native byte[] getModulus();
	public final native void setModulus(byte[] v);
	
	public final native byte[] getServerEphemeral();
	public final native void setServerEphemeral(byte[] v);
	
	public final native byte[] getHashedPassword();
	public final native void setHashedPassword(byte[] v);
	
	public final native long getVersion();
	public final native void setVersion(long v);
	
	/**
	 * GenerateProofs calculates SPR proofs.
	 */
	public native Proofs generateProofs(long bitLength) throws Exception;
	/**
	 * GenerateVerifier verifier for update pwds and create accounts
	 */
	public native byte[] generateVerifier(long bitLength) throws Exception;
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof Auth)) {
		    return false;
		}
		Auth that = (Auth)o;
		byte[] thisModulus = getModulus();
		byte[] thatModulus = that.getModulus();
		if (thisModulus == null) {
			if (thatModulus != null) {
			    return false;
			}
		} else if (!thisModulus.equals(thatModulus)) {
		    return false;
		}
		byte[] thisServerEphemeral = getServerEphemeral();
		byte[] thatServerEphemeral = that.getServerEphemeral();
		if (thisServerEphemeral == null) {
			if (thatServerEphemeral != null) {
			    return false;
			}
		} else if (!thisServerEphemeral.equals(thatServerEphemeral)) {
		    return false;
		}
		byte[] thisHashedPassword = getHashedPassword();
		byte[] thatHashedPassword = that.getHashedPassword();
		if (thisHashedPassword == null) {
			if (thatHashedPassword != null) {
			    return false;
			}
		} else if (!thisHashedPassword.equals(thatHashedPassword)) {
		    return false;
		}
		long thisVersion = getVersion();
		long thatVersion = that.getVersion();
		if (thisVersion != thatVersion) {
		    return false;
		}
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {getModulus(), getServerEphemeral(), getHashedPassword(), getVersion()});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("Auth").append("{");
		b.append("Modulus:").append(getModulus()).append(",");
		b.append("ServerEphemeral:").append(getServerEphemeral()).append(",");
		b.append("HashedPassword:").append(getHashedPassword()).append(",");
		b.append("Version:").append(getVersion()).append(",");
		return b.append("}").toString();
	}
}

